// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from dataspeed_dbw_gateway:msg/StaticArrays.idl
// generated code does not contain a copyright notice
#include "dataspeed_dbw_gateway/msg/detail/static_arrays__rosidl_typesupport_fastrtps_cpp.hpp"
#include "dataspeed_dbw_gateway/msg/detail/static_arrays__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace dataspeed_dbw_gateway
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const dataspeed_dbw_gateway::msg::ExampleMessage &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  dataspeed_dbw_gateway::msg::ExampleMessage &);
size_t get_serialized_size(
  const dataspeed_dbw_gateway::msg::ExampleMessage &,
  size_t current_alignment);
size_t
max_serialized_size_ExampleMessage(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace dataspeed_dbw_gateway


namespace dataspeed_dbw_gateway
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_dataspeed_dbw_gateway
cdr_serialize(
  const dataspeed_dbw_gateway::msg::StaticArrays & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: t_float
  {
    cdr << ros_message.t_float;
  }
  // Member: t_double
  {
    cdr << ros_message.t_double;
  }
  // Member: t_char
  {
    cdr << ros_message.t_char;
  }
  // Member: t_bool
  {
    cdr << ros_message.t_bool;
  }
  // Member: t_octet
  {
    cdr << ros_message.t_octet;
  }
  // Member: t_u8
  {
    cdr << ros_message.t_u8;
  }
  // Member: t_i8
  {
    cdr << ros_message.t_i8;
  }
  // Member: t_u16
  {
    cdr << ros_message.t_u16;
  }
  // Member: t_i16
  {
    cdr << ros_message.t_i16;
  }
  // Member: t_u32
  {
    cdr << ros_message.t_u32;
  }
  // Member: t_i32
  {
    cdr << ros_message.t_i32;
  }
  // Member: t_u64
  {
    cdr << ros_message.t_u64;
  }
  // Member: t_i64
  {
    cdr << ros_message.t_i64;
  }
  // Member: t_string
  {
    cdr << ros_message.t_string;
  }
  // Member: t_wstring
  {
    std::wstring wstr;
    for (size_t i = 0; i < 8; i++) {
      rosidl_typesupport_fastrtps_cpp::u16string_to_wstring(ros_message.t_wstring[i], wstr);
      cdr << wstr;
    }
  }
  // Member: t_bounded_string
  {
    cdr << ros_message.t_bounded_string;
  }
  // Member: t_bounded_wstring
  {
    std::wstring wstr;
    for (size_t i = 0; i < 8; i++) {
      rosidl_typesupport_fastrtps_cpp::u16string_to_wstring(ros_message.t_bounded_wstring[i], wstr);
      cdr << wstr;
    }
  }
  // Member: t_message
  {
    for (size_t i = 0; i < 8; i++) {
      dataspeed_dbw_gateway::msg::typesupport_fastrtps_cpp::cdr_serialize(
        ros_message.t_message[i],
        cdr);
    }
  }
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_dataspeed_dbw_gateway
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  dataspeed_dbw_gateway::msg::StaticArrays & ros_message)
{
  // Member: t_float
  {
    cdr >> ros_message.t_float;
  }

  // Member: t_double
  {
    cdr >> ros_message.t_double;
  }

  // Member: t_char
  {
    cdr >> ros_message.t_char;
  }

  // Member: t_bool
  {
    cdr >> ros_message.t_bool;
  }

  // Member: t_octet
  {
    cdr >> ros_message.t_octet;
  }

  // Member: t_u8
  {
    cdr >> ros_message.t_u8;
  }

  // Member: t_i8
  {
    cdr >> ros_message.t_i8;
  }

  // Member: t_u16
  {
    cdr >> ros_message.t_u16;
  }

  // Member: t_i16
  {
    cdr >> ros_message.t_i16;
  }

  // Member: t_u32
  {
    cdr >> ros_message.t_u32;
  }

  // Member: t_i32
  {
    cdr >> ros_message.t_i32;
  }

  // Member: t_u64
  {
    cdr >> ros_message.t_u64;
  }

  // Member: t_i64
  {
    cdr >> ros_message.t_i64;
  }

  // Member: t_string
  {
    cdr >> ros_message.t_string;
  }

  // Member: t_wstring
  {
    std::wstring wstr;
    for (size_t i = 0; i < 8; i++) {
      cdr >> wstr;
      bool succeeded = rosidl_typesupport_fastrtps_cpp::wstring_to_u16string(wstr, ros_message.t_wstring[i]);
      if (!succeeded) {
        fprintf(stderr, "failed to create wstring from u16string\n");
        return false;
      }
    }
  }

  // Member: t_bounded_string
  {
    cdr >> ros_message.t_bounded_string;
  }

  // Member: t_bounded_wstring
  {
    std::wstring wstr;
    for (size_t i = 0; i < 8; i++) {
      cdr >> wstr;
      bool succeeded = rosidl_typesupport_fastrtps_cpp::wstring_to_u16string(wstr, ros_message.t_bounded_wstring[i]);
      if (!succeeded) {
        fprintf(stderr, "failed to create wstring from u16string\n");
        return false;
      }
    }
  }

  // Member: t_message
  {
    for (size_t i = 0; i < 8; i++) {
      dataspeed_dbw_gateway::msg::typesupport_fastrtps_cpp::cdr_deserialize(
        cdr,
        ros_message.t_message[i]);
    }
  }

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_dataspeed_dbw_gateway
get_serialized_size(
  const dataspeed_dbw_gateway::msg::StaticArrays & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: t_float
  {
    size_t array_size = 8;
    size_t item_size = sizeof(ros_message.t_float[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: t_double
  {
    size_t array_size = 8;
    size_t item_size = sizeof(ros_message.t_double[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: t_char
  {
    size_t array_size = 8;
    size_t item_size = sizeof(ros_message.t_char[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: t_bool
  {
    size_t array_size = 8;
    size_t item_size = sizeof(ros_message.t_bool[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: t_octet
  {
    size_t array_size = 8;
    size_t item_size = sizeof(ros_message.t_octet[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: t_u8
  {
    size_t array_size = 8;
    size_t item_size = sizeof(ros_message.t_u8[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: t_i8
  {
    size_t array_size = 8;
    size_t item_size = sizeof(ros_message.t_i8[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: t_u16
  {
    size_t array_size = 8;
    size_t item_size = sizeof(ros_message.t_u16[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: t_i16
  {
    size_t array_size = 8;
    size_t item_size = sizeof(ros_message.t_i16[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: t_u32
  {
    size_t array_size = 8;
    size_t item_size = sizeof(ros_message.t_u32[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: t_i32
  {
    size_t array_size = 8;
    size_t item_size = sizeof(ros_message.t_i32[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: t_u64
  {
    size_t array_size = 8;
    size_t item_size = sizeof(ros_message.t_u64[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: t_i64
  {
    size_t array_size = 8;
    size_t item_size = sizeof(ros_message.t_i64[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: t_string
  {
    size_t array_size = 8;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        (ros_message.t_string[index].size() + 1);
    }
  }
  // Member: t_wstring
  {
    size_t array_size = 8;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        wchar_size *
        (ros_message.t_wstring[index].size() + 1);
    }
  }
  // Member: t_bounded_string
  {
    size_t array_size = 8;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        (ros_message.t_bounded_string[index].size() + 1);
    }
  }
  // Member: t_bounded_wstring
  {
    size_t array_size = 8;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        wchar_size *
        (ros_message.t_bounded_wstring[index].size() + 1);
    }
  }
  // Member: t_message
  {
    size_t array_size = 8;

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        dataspeed_dbw_gateway::msg::typesupport_fastrtps_cpp::get_serialized_size(
        ros_message.t_message[index], current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_dataspeed_dbw_gateway
max_serialized_size_StaticArrays(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: t_float
  {
    size_t array_size = 8;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: t_double
  {
    size_t array_size = 8;

    current_alignment += array_size * sizeof(uint64_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint64_t));
  }

  // Member: t_char
  {
    size_t array_size = 8;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: t_bool
  {
    size_t array_size = 8;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: t_octet
  {
    size_t array_size = 8;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: t_u8
  {
    size_t array_size = 8;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: t_i8
  {
    size_t array_size = 8;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: t_u16
  {
    size_t array_size = 8;

    current_alignment += array_size * sizeof(uint16_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint16_t));
  }

  // Member: t_i16
  {
    size_t array_size = 8;

    current_alignment += array_size * sizeof(uint16_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint16_t));
  }

  // Member: t_u32
  {
    size_t array_size = 8;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: t_i32
  {
    size_t array_size = 8;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: t_u64
  {
    size_t array_size = 8;

    current_alignment += array_size * sizeof(uint64_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint64_t));
  }

  // Member: t_i64
  {
    size_t array_size = 8;

    current_alignment += array_size * sizeof(uint64_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint64_t));
  }

  // Member: t_string
  {
    size_t array_size = 8;

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: t_wstring
  {
    size_t array_size = 8;

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        wchar_size *
        1;
    }
  }

  // Member: t_bounded_string
  {
    size_t array_size = 8;

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        8 +
        1;
    }
  }

  // Member: t_bounded_wstring
  {
    size_t array_size = 8;

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        wchar_size *
        8 +
        wchar_size *
        1;
    }
  }

  // Member: t_message
  {
    size_t array_size = 8;


    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      current_alignment +=
        dataspeed_dbw_gateway::msg::typesupport_fastrtps_cpp::max_serialized_size_ExampleMessage(
        inner_full_bounded, inner_is_plain, current_alignment);
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  return current_alignment - initial_alignment;
}

static bool _StaticArrays__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const dataspeed_dbw_gateway::msg::StaticArrays *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _StaticArrays__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<dataspeed_dbw_gateway::msg::StaticArrays *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _StaticArrays__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const dataspeed_dbw_gateway::msg::StaticArrays *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _StaticArrays__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_StaticArrays(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _StaticArrays__callbacks = {
  "dataspeed_dbw_gateway::msg",
  "StaticArrays",
  _StaticArrays__cdr_serialize,
  _StaticArrays__cdr_deserialize,
  _StaticArrays__get_serialized_size,
  _StaticArrays__max_serialized_size
};

static rosidl_message_type_support_t _StaticArrays__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_StaticArrays__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace dataspeed_dbw_gateway

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_dataspeed_dbw_gateway
const rosidl_message_type_support_t *
get_message_type_support_handle<dataspeed_dbw_gateway::msg::StaticArrays>()
{
  return &dataspeed_dbw_gateway::msg::typesupport_fastrtps_cpp::_StaticArrays__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, dataspeed_dbw_gateway, msg, StaticArrays)() {
  return &dataspeed_dbw_gateway::msg::typesupport_fastrtps_cpp::_StaticArrays__handle;
}

#ifdef __cplusplus
}
#endif
